﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using Polly.Contrib.Simmy;
using Polly.Contrib.Simmy.Behavior;
using SimmyBehavior.Data;

namespace SimmyBehavior.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class ProductsController : ControllerBase
    {
        private readonly SalesContext _salesContext;

        AsyncInjectBehaviourPolicy _behaviorPolicy;
        public ProductsController(SalesContext salesContext)
        {
            _behaviorPolicy = MonkeyPolicy.InjectBehaviourAsync(
                 async () =>
                 {
                     await _salesContext.Database.ExecuteSqlCommandAsync("DROP TABLE Products");
                     Console.WriteLine("Dropped the Products table.");
                 },
                 0.25, // 25% of the time this policy will execute
                async () => await Task.FromResult(true));
            _salesContext = salesContext;
        }

        [HttpGet]
        public async Task<ActionResult> Get()
        {
            List<Product> products =  await _behaviorPolicy.ExecuteAsync(async () => await _salesContext.Products.Take(10).ToListAsync());

            return Ok(products);
        }
    }
}
